
// This is used to test failing cases in test/3b_remotelistener_downloader.js.

const Logger            = require('woveon-logger');

const Service           = require('../service/service');
const DownloaderEngine  = require('../test/downloaderEngine');
const Helper            = require('../test/helper');

let logger   = new Logger('t', { debug: true, showName: true },
                    {fetchRSOnAndBefore : true, fetchRSOnAndAfter: true,
                     addMsg: true, doLoop: true, sipChannelData: true, setToTime: true, engine : true});
let sim      = new Helper.SimulatedRemoteService(5, logger);
let de       = new DownloaderEngine(0, logger);
sim.linkToEngine(de);


function AddMsg(_d) { sim.setPost(_d[0],_d[1]); }

AddMsg([68,"VGBHJ"]);
AddMsg([168,"5DB2I"]);
AddMsg([211,"9T7KR"]);
AddMsg([306,"U6DOH"]);
AddMsg([345,"MNHGV"]);
AddMsg([445,"R898J"]);
AddMsg([495,"IARQ0"]);
AddMsg([543,"YV93R"]);
AddMsg([553,"DVWGC"]);
AddMsg([600,"CSTAG"]);
AddMsg([646,"7F8KI"]);
AddMsg([648,"3XTMW"]);
AddMsg([691,"VCE68"]);
AddMsg([762,"8S8I9"]);
AddMsg([860,"DIQRQ"]);
AddMsg([882,"TW5OM"]);
AddMsg([882,"N0N2A"]);
AddMsg([969,"LPNHZ"]);
AddMsg([1013,"CASD9"]);
AddMsg([1092,"6GSLG"]);



// Test case 2
// --------------------------------------------------------------------- 
let start_t = 495;  // change
let start_m = 256;  // change
let cur     = 1500; // max


logger.info(` - curtime ${start_t}, monitored from ${start_m}, going to ${cur}`);


// run this as async
(async () => {
  let i = 0;

  let rnd1 = [509,580,678,750,799,812,868,928,933,935,976,989,1009,1071,1081,1143];  // change
  let rnd2 = [2,3,5,3];              // change

  // do all sim.setToTime first, then do.doLoop
  logger.h3().info(`* setToTime, then doLoop`);
  sim.resetSim(start_t, start_m);
  sim.displayMe(`monitor at ${start_m}`);
  while ( sim._curtime < cur ) {
    let newtime = rnd1[i]; // sim._curtime + Math.round((Math.random() * 100.0));
    logger.info(`  - 1. setToTime : ${newtime}`);
    sim.setToTime(newtime);
    i++;
  }
  logger.info('- simulation out of messages to arrive');

  i=0;
  while ( de.channel.e_first == null ) {
    let limit = rnd2[i]; // Math.round( Math.random() * 5.0);
    logger.info(`  - 1. doLoop limit: ${limit}`);
    await de.doLoop(limit);
    i++;
  }
sim.displayMe();
de.displayMe();
  sim.compareToEngine();

  /*
logger.h3().info(`* doLoop, then setToTime`);
sim.resetSim(start_t,start_m);
sim.displayMe();
let i = 0;
while( de.channel.e_first === null ) { 
  let limit = rnd1[i];//Math.round( Math.random() * 5); 
  logger.info(`* 2. doLoop limit: ${limit}`);
  await de.doLoop(limit);
  i++;
}
while( sim._curtime < cur ) {
  let newtime = sim._curtime + (Math.random() * 100.0);
  logger.info(`* 2. setToTime : ${newtime}`);
  await sim.setToTime(newtime);
}
logger.info('- simulation out of messages to arrive');
sim.displayMe();
de.displayMe();
sim.compareToEngine();
*/

})()
