

const config            = require('../service/config');
const Logger            = require('../service/logger');
const FBPlugin          = require('../plugins/facebook');


(async function () {

  let logger = new Logger('log', {debug: true, showName: true});
  logger.info('');
  logger.info('Starting listener for webhook ...');

  let wconfig = JSON.parse(JSON.stringify(config));
  let gconfig = JSON.parse(JSON.stringify(config));
  wconfig.service.port = process.env.WOV_ple_rl_port;
  gconfig.service.port = config.plugin.port;

  let fb = {
    /*
    wl: new FBPlugin.WoveonListener(gconfig,
      {
        logger: new Logger('fbG',
          { showName: true, debug: true, level: 'info' },
          { listener: false, requester: true })
      }),
      */
    remotelistener: new FBPlugin.RemoteListener(wconfig,
      {
        logger: new Logger('fbW',
          { showName: true, debug: true, level: 'verbose' },
          { listener: true, requester: true})
      }),
  };

  await fb.remotelistener.init();
  await fb.remotelistener.startup();

  logger.info('...initialized. Now...');
  logger.info(`1) Ensure 'ngrok http ${process.env.WOV_ple_rl_port}' is running...`);
  logger.info(`2) Press 'Edit subscription' button here: 'https://developers.facebook.com/apps/${process.env.WOV_fb_appId}/webhooks/'`);
  logger.info("3) Set 'Callback URL' to: 'https://<ngrok>/fbWebhooks'.");
  logger.info(`4) Set 'Verify Token' to: '${process.env.WOV_fb_verifyToken}'\n`);
  logger.info('...Ready.\n');
})();
