

const config            = require('../service/config');
const Logger            = require('woveon-logger');
const FBPlugin          = require('../plugins/facebook');


(async function() {

  let logger = new Logger('log', {debug: true, showName: true});
  logger.info('');
  logger.info('Starting listener for woveon...');

  let wconfig = JSON.parse(JSON.stringify(config));
  let gconfig = JSON.parse(JSON.stringify(config));
  wconfig.service.port = process.env.WOV_ple_rl_port;
  gconfig.service.port = config.plugin.wl_port;

  let fb = {
    wl: new FBPlugin.WoveonListener(gconfig,
      {logger: new Logger('fbG',
          {showName: true, debug: true, level: 'info'},
          {listener: false, requester: true})}),
    remotelistener: new FBPlugin.RemoteListener(wconfig,
      {logger: new Logger('fbW',
          {showName: true, debug: true, level: 'verbose'},
          {listener: true, requester: true})})};

  await fb.remotelistener.init();
  await fb.remotelistener.startup();
  await fb.wl.init();
  await fb.wl.startup();

  logger.info('...initialized. Now...');
  logger.info(`1) Open a browser to http://local-app.woveon.com`);
  logger.info('2) Add a comment to a channel.');
  logger.info('\n...Ready.\n');
})();
