

HASWOVTOOLS=$(shell which wov-env > /dev/null && echo 1 || echo 0)


#ifndef USESWOVTOOLS
#$(warning )
#$(warning ***ERROR: USESWOVTOOLS is not set. It is used to set env variables. So,)
#$(warning   - "export USESWOVTOOLS=1" to use WovTools (if you have it installed))
#$(warning   - "export USESWOVTOOLS=0" to not use WovTools (use current env vars))
#$(warning   NOTE 1: Set to "0" if managing env settings yourself)
#$(warning   NOTE 2: In a Kubernetes pod, just run the command directly w/o using make.)
#$(warning )
#$(error )
#endif

#ifeq ($(PLUGIN_NAME),)
#$(error ERROR: PLUGIN_NAME needs to be defined in your Makefile.)
#endif

TESTSERVERPORT=3010

# If useswovtools, that is the basis of env vars
ifeq ($(HASWOVTOOLS),1)

# rebuild environment if needed
#ifneq ($(shell wov-ns-check),)
#$(warning Kubernetes namespace mismatch, run 'wov-ns-check'.)
#endif

# Fail if in production
ifeq ($(shell wov-env --var WOV_STAGE),prod)
$(warning )
$(warning )
$(error ERROR: Can not run in production!!!)
endif

#ENVS=$(shell cd `wov-cd -e api`; wov-env --conf)
#ENVS=$(shell wov-env --conf)
MICROSERVICE=$(shell wov-env --var WOV_PROJECT)
ENVS=$(shell wov-env --CM ${MICROSERVICE}) $(shell wov-env --SE ${MICROSERVICE})


else ifneq ($(WOV_PROJECT),) 
$(warn using environment variables)

else
ifndef PLUGIN_NAME
$(error PLUGIN_NAME is not set)
endif
ifndef PLUGIN_TITLE
$(error PLUGIN_TITLE is not set)
endif
WOV_we_wl_port=50105
ENVS= WOV_api_ver='v1' \
      WOV_we_wl_port=${WOV_we_wl_port} \
			WOV_we_rl_port=50106 \
			WOV_we_ov_port=50107 \
			WOV_we_outofdateseconds=10 \
			WOV_we_wl_url='http://localhost' \
			WOV_we_rl_url='http://localhost' \
			WOV_we_ov_url='http://localhost' \
			WOV_we_db_url='localhost' \
			WOV_we_db_collection='we' \
			WOV_www_app_fullurl='http://app-me.test.com' \
			WOV_api_fullurl='http://localhost:3010' \
			WOV_we_apisecret="${WOV_plugin_apisecret}" \
			WOV_we_datasecret="${WOV_plugin_datasecret}" \
			WOV_plugin_id=1 \
			WOV_STAGE=me \
      WOV_ME=me \
      WOV_api_port_ext=3010

endif

