
# Rules useful for plugins

# ---------------------------------------------------------------------
# ---------------------------------------------------------------------
#all:
#	@echo
#	@echo "*** Build and Run"
#	@echo "'make run-{microservice}' : start the microservice"
#	@echo "'make devrun-{microservice}' : start the microservice with nodemon"
##	@echo "'make container-{microservice}' : build the container"
##	@echo "'make deploy-{microservice}' : deploy the container to Docker repo"
#	@echo
#	@echo "*** Utility"
##	@echo "'make wovtms-pconfig' : print environment information"
#	@echo "'make local-tests'    : run tests."
#	@echo "'make envs'           : display and test env vars are set"
#	@echo


# ---------------------------------------------------------------------
#  run-(service) - run services locally
#    - either run mongo locally or port forward to the mongo db
#      (and kill off all services in cloud)
#      - ex. wov-portforward plemdb-cw-mongodb
#               NOTE: '-c' to clear all existing port forwards
#            wov-portforward plemwl
# ---------------------------------------------------------------------

run-${PLUGIN_NAME}wl : .FORCE
	@echo "- $(@) --------------------------------------------------------------"
	${ENVS} npm run wl

run-${PLUGIN_NAME}rl: .FORCE
	@echo "- $(@) --------------------------------------------------------------"
	${ENVS} npm run rl

run-${PLUGIN_NAME}ov: .FORCE
	@echo "- $(@) --------------------------------------------------------------"
	${ENVS} npm run ov

devrun-${PLUGIN_NAME}wl: .FORCE
	@echo "- $(@) --------------------------------------------------------------"
	${ENVS} npm run devwl

devrun-${PLUGIN_NAME}rl: .FORCE
	@echo "- $(@) --------------------------------------------------------------"
	${ENVS} npm run devrl

devrun-${PLUGIN_NAME}ov: .FORCE
	@echo "- $(@) --------------------------------------------------------------"
	${ENVS} npm run devov


listen: .FORCE
	@echo "- $(@) --------------------------------------------------------------"
	@if [ -f bin/listen.js ]; then ${ENVS} node bin/listen.js; else echo "ERROR: no bin/listen.js implemented yet."; exit 1; fi

send: .FORCE
	@echo "- $(@) --------------------------------------------------------------"
	@if [ -f bin/send.js ]; then ${ENVS} node bin/send.js; else echo "ERROR: no bin/send.js implemented yet."; exit 1; fi


## Test when using bastion security
#pre-local-test: .FORCE
#	@echo "- $(@) --------------------------------------------------------------"
#	@echo " ... test testserver is running"
#	@curl -q http://localhost:${TESTSERVERPORT}/api/v1/health > /dev/null 2>&1 || (echo "FAILED: 'cd woveon-engine-p/testserver' and 'make run', to start the testserver" ; exit 1)
#	@echo " ... test mongodb connection is active"
#	@mongo --eval "printjson(\"\")" > /dev/null 2>&1 || (echo "FAILED: run mongo in docker locally via 'docker run --name some-mongo -p 27017:27017 -d mongo:3.6-jessie'" ; exit 1)
#
#
## Switched to bastion, so I can clean this up
#local-tests : pre-local-test check_pass_and_secrets .FORCE
#	${ENVS} mocha -b $$TEST
