
const DB = require('../service/db');
let Schema = DB.Mongoose.Schema;

/**
 * This stores the data of a Res object that was unable to complete. Probably due to missing data, and so it is waiting for
 * new data to occur from the RemoteService.
 *   ex. an email message that is a reply to an email that we have yet to find.
 */

module.exports = (_db) => {
  let retval = null;
  let IncompleteResSchema = null;

  try {
    IncompleteResSchema = new Schema({
      remoteParentId : {type : String},
      _wovdata       : {type : Schema.Types.Mixed, default : {}}, // Mixed
      _rsdata        : {type : Schema.Types.Mixed, default : {}}, // Mixed
    });
  }
  catch (err) { console.log(err); throw new Error('Failed to create a schema for IncompleteRes.'); }

  // try to grab cached. note, since Mongoose caches them inernally, and not per connection, I am doing this.
  try         { retval = _db.connection.model('IncompleteRes'); }
  catch (err) { retval = _db.connection.model('IncompleteRes', IncompleteResSchema); }

  return retval;
};
