//'use strict';
const DB = require('../service/db');
DB.Mongoose.Promise = Promise;
let Schema = DB.Mongoose.Schema;


module.exports = (_db) => {
  let retval = null;
  let RemoteListenerSchema = null;

  try {

    RemoteListenerSchema = new Schema({
      numchannels    : Number, // NOTE: rough estimate! updated periodically for load balancing
      address_ip     : String,
      address_family : String,
      address_port   : Number,
      isValid        : Boolean, // true until watcher sets false
    }, {
        timestamps: true, // createdAt, updatedAt
      });
  } catch (err) {console.log(err); throw new Error('RemoteListenerSchema failed to create.');}

//  _db.logger.info('****************** new RemoteListener for db: ',_db.id);

  // try to grab cached. note, since Mongoose caches them inernally, and not
  // per connection, I am doing this.
  try {
    retval = _db.connection.model('RemoteListeners');//, RemoteListenerSchema);
//    _db.logger.info('cached model, so reusing');
  }
  catch (err) {
//    _db.logger.info('no cached model, so creating scheme');
    retval = _db.connection.model('RemoteListeners', RemoteListenerSchema);
  }

  // console.log(__filename, ') creating model :', DB.Mongoose.cw);

  return retval;
};
