let h      = require('./msHelper')(__filename);
// const wtf    = require('wtfnode');
const ResLib   = require('../src/service').ResLib;
const MessageResProto = require('../src/service/restypes/').Message;
const uuidv4 = require('uuid/v4');

// const Post                  = h.WE.Resource.Post;
// let tPost                   = h.PLT.plResource.tPost;
//
// Create the PostEmailModel
let s    = null;

// new h.PE.Service.WEConfig(new Logger('config', {debug : true}));


let resp           = new MessageResProto();
const plp          = new (require('../pltest/src/pl/resMessage'))();
const MessageModel = new ResLib.ResModel(resp, plp);

describe(`${h.mtag}: Test the Res object's Mongoose model features, with test plugin`, () => {

  it(`${h.mtag}: ...resource`, async () => {


    // create resource
    let xid = uuidv4();
    let wdata  = {xid : xid, xidTop : xid, xidParent : null,  resInc : 5678, token : 'C', author : 'Chas A Smith'};
    let rsdata = {
      author          : {first : 'Chas', last : 'Smith', aid : '121314'},
      subject         : 'Chas say\'n hi',
      staysInPluginDB : 'hi',
    };

    h.logger.lvl('verbose');

    h.logger.verbose('  ... create a service');
    s = new h.PE.Service({name : 'tService'});

    h.logger.verbose('  ... push service to init status so db is active');
    await s.init();

    h.logger.verbose('  ... create a resource');
    let res = await MessageModel.generateRes(wdata, rsdata); // false so it does not create the models yet

    h.logger.info('res : ', res.reqWovData());

    h.logger.verbose('  ... init the model');
    MessageModel.connect(s.db);
    h.logger.info('model = ', res.getType());
    MessageModel.models.deleteMany({}); // clear database


    /*
    h.logger.info('WovData : ', res.reqWovData());
    h.logger.info('WovID   : ', res.reqWovID());
    h.logger.info('PLData  : ', res.reqPLData());
    h.logger.info('wovdata : ', res._wovdata);
    h.logger.info('rsdata  : ', res._rsdata);
    */

    h.logger.info('create document, with ".data" from: ', res.reqPLData());
    let d = await res.updateMongo();
    h.logger.info('d: ', d);

    h.logger.verbose('... now retreive it and compare');

    h.logger.verbose(`... find the saved model, by looking for xid="${wdata.xid}"`);
    let dd = await MessageModel.models.findOne({xid : wdata.xid}).lean(); // lean(), so a simple object, not mongoose
    // h.logger.verbose('... found: ', dd);
    expect(dd.xid).to.equal(wdata.xid);
    expect(dd.xid).to.equal(d.get('xid'));

//    once this works, check in code and amke docker containers to send to plem


    h.logger.lvl('info');
  });


  after( async function() {
    // h.logger.info('wtf dump: '); wtf.dump();
    // h.logger.info('s.db: ', s.db);
    // h.logger.info('s.db: ', s.db.isConnected());
    if ( s.db.isConnected() ) await s.db.close();
  });

});
