

const h      = require('./msHelper')(__filename);
const WE     = require('../src');
const ResLib = WE.Service.ResLib;
// const uuidv4 = require('uuid/v4');
// const MessageResProto = require('../src/service/restypes/message');

// const PLT     = require('../pltest/src/pl');
// const WEConfig = PLT.WoveonListener.WEConfig;
//

let logger = h.logger;


let mtag = h.mtag;

  const wovp         = new WE.Service.ResTypes.Message();
  const rsp          = new (require('../pltest/src/pl/resMessage'))();
  const MessageModel = new ResLib.ResModel(wovp, rsp);

describe(`${mtag}: Res test`, async () => {


  before( async ()=>{
    // rl = await h.genRL(false, true, true, );
    // TestModel = rl.MessageModel;
  });


  it(`${h.mtag}: ...simple woveon created resource`, async function() {
    logger.h3().info(this.test.title);

    let wovdata = {
      token   : 'A',
      author  : 'Adam Smith',
      subject : 'Hi from My Company',
      message : 'Yo',
    };
    let rsdata = {};
    let res = MessageModel.generateRes(wovdata, rsdata, 'channel');
    // logger.info('res: ', res._wovdata, res._rsdata);
    // res.displaySchema();
    // res.displayStructure();
    // res.displayData();
    // logger.info(' pltest res1: ', res._wovdata, res._rsdata);
    expect(res.getToken()).to.equal(wovdata.token);
    expect(res.getAuthor()).to.equal(wovdata.author);
    expect(res.getSubject()).to.equal(wovdata.subject);
    expect(res._wovdata.xidTop).to.equal(undefined);
    expect(res._wovdata.xidParent).to.equal(undefined);
    expect(res._wovdata.remoteId).to.equal(undefined);
    expect(res._wovdata.remoteParentId).to.equal(undefined);
  });


  it(`${h.mtag}: ...test merge function `, async function() {
    logger.h3().info(this.test.title);

    let wovdata = {
      token   : 'A',
      subject : 'Hi from My Company',
      message : 'Yo',
    };
    let rsdata = {plauthor : 'A Aron Smith'};
    let res = MessageModel.generateRes(wovdata, rsdata, 'channel');
    expect(res.getAuthor()).to.equal(rsdata.plauthor);
  });


  it(`${h.mtag}: ...test rsdata precedence`, async function() {
    logger.h3().info(this.test.title);

    let wovdata = {
      token   : 'A',
      author  : 'Adam Smith',
      subject : 'Hi from My Company',
      message : 'Yo',
    };
    let rsdata = {plauthor : 'A Aron Smith'};
    let res = MessageModel.generateRes(wovdata, rsdata, 'channel');
    expect(res.getAuthor()).to.equal(rsdata.plauthor);
  });


  it(`${h.mtag}: ...some functions should set wovdata for faster calling`, async function() {
    logger.h3().info(this.test.title);

    let wovdata = {
      token   : 'A',
      author  : 'Adam Smith',
      subject : 'Hi from My Company',
      message : 'Yo',
    };
    let rsdata = {
      plauthor : 'A Aron Smith',
      // created_time : 1,
    };
    let res = MessageModel.generateRes(wovdata, rsdata, 'channel');

    expect(res._wovdata.resInc).to.be.undefined;
    let resinc = null;
    try { resinc = res.getResInc(); }
    catch (e) {}
    expect(resinc).to.be.null;
    res._rsdata.created_time = 1;
    resinc = res.getResInc();
    expect(resinc).to.not.be.null;
    expect(res._wovdata.resInc).to.not.be.null;
    expect(resinc.equals(res._wovdata.resInc)).to.be.true;
  });


  it(`${h.mtag}: ...completeness checks`, async function() {
    logger.h3().info(this.test.title);

    let wovdata = {
      token   : 'A',
      author  : 'Adam Smith',
      subject : 'Hi from My Company',
      message : 'Yo',
    };
    let rsdata = {
      plauthor     : 'A Aron Smith',
      created_time : 1,
    };
    let res = MessageModel.generateRes(wovdata, rsdata, 'channel');

    res.getResInc();
    expect(res.isComplete()).to.be.false;

    // logger.info('set values and try again');
    res._rsdata.pltestRemoteId       = 'remote1';
    res._rsdata.pltestRemoteParentId = null; // 'remoteparent1'; set to null so postprocessing can complete
    expect(res.isComplete()).to.be.false;

    // NOTE: would run RL.postProcess now, but instead, just assuming the outcome (test that algorithm later)
    // logger.info('post process and try again');
    res.applyPostProcessing({xidTop : res.getXID(), xidParent : null});
    expect(res.isComplete()).to.be.false;

    // logger.info('call functions that set wovdata and try again');
    // NOTE: these two functions would be called in postProcessing and not be needed to be called here
    res.getRemoteID();
    res.getRemoteParentID();
    expect(res.isComplete()).to.be.true;

    /*
    now create the postProcessing function in RL
    ... i.e. setting one
    ex. remoteDataSipper::postProcessRes_Messages_NonHierarchy
          .. and this func needs to call res::postProcessing(vals) on each res. to set calues
          */
  });

  after( async () => {
    logger.h1().info(`${mtag} shutting down`);
    // await rl.doShutdown();
  });

});

