// Imported Code


const should            = require('should');
const expect            = require('chai').expect;

const Service           = require('../src/service');
const DownloaderEngine  = require('./downloaderEngine');

// THESE ARE HELPER FUNCTIONS... since the Inc for these tests is a 32 bit number and Inc is a Long, these "longify" an int (l) and "intify" a Long (i).
const l                 = Service.l;
const i                 = Service.i;

let SimulatedRemoteService = require('./simulatedRemoteService');
let h                   = require('./msHelper')(__filename);
let logger              = h.logger;

logger.warn('NOTE: this test case has issues that occur randomly... need to fix');

let slogger  = new h.Logger('s', {debug : true, showName : true},
                      {setToTime : true, sippernotification : true});
let delogger = new h.Logger('e', {debug : true, showName : true}, {
    engine             : true,
    doLoop             : true,
    sipChannelData     : true,
    fetchOnAndBefore   : true,
    pruneOnAndBefore   : true,
    sippernotification : true,
  });
let sim = null;
let de = null;
let curtime = 0;

/**
 * Helper
 * @param {int} _v - turns into a Long
 * @return {Long} -
 */
// function l(_v) {return Long.fromInt(_v);}

describe(`${h.mtag}: Call remotelistener downloader functionality::`, function() {


  // setup the service
  before( () => {
    logger.h1().info(this.title);
  });


  describe(`${h.mtag}: Pre. Test Simulated Service functions::`, function() {

    before(() => {
      logger.h1().info(this.title);
      sim = new SimulatedRemoteService(l(5), slogger, h.config);
      de = new DownloaderEngine(l(0), delogger); sim.linkToEngine(de);

      sim.setPost(l(1), Service.generateOrderedString(5));
      sim.setPost(l(2), Service.generateOrderedString(5));
      sim.setPost(l(3), Service.generateOrderedString(5));
      sim.setPost(l(4), Service.generateOrderedString(5));
      sim.setPost(l(6), Service.generateOrderedString(5));
      sim.displayMe('test data for Pre Tests');
    });

    it(`${h.mtag}: Pre. fetchOnAndBefore `, async function() {
      logger.h2().info(this.test.title);


      (await de.fetchOnAndBefore(l(7), 0)).data.length.should.equal(0);
      (await de.fetchOnAndBefore(l(6), 1)).data.length.should.equal(1);
      (await de.fetchOnAndBefore(l(1), 1)).data.length.should.equal(1);
      (await de.fetchOnAndBefore(l(5), 1)).data.length.should.equal(1);
      (await de.fetchOnAndBefore(l(4), 1)).data.length.should.equal(1);
      (await de.fetchOnAndBefore(l(4), 3)).data.length.should.equal(3);
      (await de.fetchOnAndBefore(l(4), 4)).data.length.should.equal(4);
      (await de.fetchOnAndBefore(l(4), 5)).data.length.should.equal(4);
    });


  });


  describe(`${h.mtag}: A. State 1, no bounds (i.e. _e,_l)`, function() {

    before( ()=> { logger.h1().info(this.title); });

    it(`${h.mtag}: Basic test: State 1: null `, async function() {
      logger.h2().info(this.test.title);

      curtime = l(1);
      monitor = l(0);
      sim = new SimulatedRemoteService(l(0), slogger, h.config);
      de = new DownloaderEngine(monitor, delogger); sim.linkToEngine(de);

      // load data
      sim.setPost(curtime, Service.generateOrderedString(5));

      // actions
      sim.displayMe('pre');
      logger.info(`channel data: ${JSON.stringify(de.channel, null, null)} curtime:  ${sim._curtime}`);
      await sim.setToTime(l(curtime));
      logger.info(`channel data: ${JSON.stringify(de.channel, null, null)} curtime:  ${sim._curtime}`);
      sim.displayMe('post');

      // check engine 4 values
      sim._curtime.should.equal(curtime);
      logger.info('adsfadsf: ', de.channel.sipBlocks);
      expect(de.channel.sipBlocks[0].p).to.equal(curtime);
      // de.channel.sipBlocks[0].p.should.equal(curtime);
      de.channel.sipBlocks[0].l.should.equal(curtime);
      logger.info(' sipBlocks 0 f: ', de.channel.sipBlocks[0]);
      expect(de.channel.sipBlocks[0].f.equals(l(0))).to.equal(true);
      // should.equal(de.channel.sipBlocks[0].f, null);
      de.channel.e_mon.should.equal(monitor);
      sim.displayMe(); de.displayMe();
      sim.compareToEngine();
    });

    it(`${h.mtag}: More data test: State 1: null `, async function() {
      logger.h2().info(this.test.title);
      logger.lvl('verbose');

      sim = new SimulatedRemoteService(l(0), slogger, h.config);
      de  = new DownloaderEngine(l(0), delogger); sim.linkToEngine(de);

      // load data
      sim.setPost(l(3),  Service.generateOrderedString(5));
      sim.setPost(l(8),  Service.generateOrderedString(5));
      sim.setPost(l(12), Service.generateOrderedString(5));

      // action: still no data
      await sim.setToTime(l(2));
      sim.displayMe();
      expect(sim._curtime.equals(l(2))).to.equal(true);
      de.posts.length.should.equal(0);
      de.channel.sipBlocks.length.should.equal(0);
//      should.equal(de.channel.sipBlocks[0].p, null);
//      should.equal(de.channel.sipBlocks[0].l, null);
//      should.equal(de.channel.sipBlocks[0].f, null);

      // action: just got data
      logger.verbose('just got data');
      await sim.setToTime(l(3));
      sim.displayMe();
      i(sim._curtime).should.equal(3);
      de.posts.length.should.equal(1);
      should.equal(de.channel.sipBlocks[0].p, 3);
      should.equal(de.channel.sipBlocks[0].l, 3);

      // action: no more data
      logger.verbose('no more data');
      await sim.setToTime(l(4));
      sim.displayMe();
      de.posts.length.should.equal(1);
      i(sim._curtime).should.equal(4);
      should.equal(i(de.channel.sipBlocks[0].p), 3);
      should.equal(i(de.channel.sipBlocks[0].l), 3);

      // action: no more data
      await sim.setToTime(l(15));
      sim.displayMe();
      de.posts.length.should.equal(3);
      i(sim._curtime).should.equal(15);
      should.equal(i(de.channel.sipBlocks[0].p), 3);
      should.equal(i(de.channel.sipBlocks[0].l), 12);

      logger.lvl('info');
    });

    it(`${h.mtag}: Basic test: State 1: loop`, async function() {
      logger.h2().info(this.test.title);
      logger.set('level', 'verbose');

      sim = new SimulatedRemoteService(l(5), slogger, h.config);
      de = new DownloaderEngine(l(0), delogger);
      sim.linkToEngine(de);

      sim.setPost(l(1), Service.generateOrderedString(5));
      sim.setPost(l(2), Service.generateOrderedString(5));
      sim.setPost(l(3), Service.generateOrderedString(5));
      sim.setPost(l(4), Service.generateOrderedString(5));

      // precheck
      de.posts.length.should.be.equal(0);

      // actions
      logger.verbose('pre doLoop 10: get all');
      sim.displayMe('pre doLoop 10: get all');
      await de.doLoop(10);

      logger.verbose('  ... check engine 4 values');
      de.displayMe('status');
      i(de.channel.sipBlocks[0].l).should.equal(5); // rs current time: since case 1 (no bounds) requests the servers time to go back from
      i(de.channel.sipBlocks[0].p).should.equal(0); // i(de.posts[0][0])); found all
      logger.info(' sipblocks: ', de.channel.sipBlocks[0]);
      logger.info(' de.posts[0]: ', de.posts[0]);
      should.equal(i(de.channel.sipBlocks[0].f), 0); // de.posts[0][0]);
      sim.compareToEngine();

      logger.verbose('  ... Another pass, make sure resetSim works...');
      sim.resetSim(l(5), l(0));
      sim.posts.length.should.be.equal(4);
      de.posts.length.should.be.equal(0);

      logger.verbose('  ... get 2');
      sim.displayMe('pre doLoop 2 : get some');
      await de.doLoop(2);
      de.posts.length.should.equal(2);
      i(de.channel.sipBlocks[0].p).should.equal(i(de.posts[0][0]));
      i(de.channel.sipBlocks[0].l).should.equal(5); // de.posts[de.posts.length - 1][0]);
      i(sim.posts[2][0]).should.equal(i(de.posts[0][0]));
      i(sim.posts[3][0]).should.equal(i(de.posts[de.posts.length - 1][0]));


      logger.verbose('  ... Another pass, get 1');
      sim.resetSim(l(5), l(0));
      sim.displayMe('pre doLoop 1 : get one');
      await de.doLoop(1);
      de.posts.length.should.equal(1);
      i(de.channel.sipBlocks[0].p).should.equal(i(de.posts[0][0]));
      i(de.channel.sipBlocks[0].l).should.equal(5); // de.posts[de.posts.length - 1][0]);
      i(sim.posts[3][0]).should.equal(i(de.posts[0][0]));
      i(sim.posts[3][0]).should.equal(i(de.posts[de.posts.length - 1][0]));

      logger.verbose('  ... Another pass, get none');
      sim.resetSim(l(5), l(0));
      sim.displayMe('pre doLoop 0 : get none');
      await de.doLoop(0);
      de.posts.length.should.equal(0);
      logger.info('channel ', de.channel);
      should.equal(i(de.channel.sipBlocks[0].p), 5);
      should.equal(i(de.channel.sipBlocks[0].l), 5);

      logger.verbose('  ... check when get all');
      sim.resetSim(l(5), l(0));
      sim.displayMe('doLoop get all');
      await de.doLoop(10);
      de.posts.length.should.equal(4);
      should.equal(i(de.channel.sipBlocks[0].p), 0); // de.posts[0][0]);
      should.equal(i(de.channel.sipBlocks[0].l), 5); // de.posts[3][0]);

      logger.verbose('  ... check doLoop when curtime is 0 and retunrs nothign and set _f');
      sim.resetSim(l(0), l(0));
      await de.doLoop(10);
      de.posts.length.should.equal(0);
      de.displayMe('');
      logger.info('channel ', de.channel);
      should.equal(de.channel.sipBlocks[0].p, 0);
      should.equal(de.channel.sipBlocks[0].l, 0);
      console.log('f is ', de.channel.sipBlocks[0].f);
      expect(i(de.channel.sipBlocks[0].f)).to.equal(0); // curtime

      logger.verbose('  ... because been monitoring since 5, does not use curtime but monitor time');
      sim.resetSim(l(0), l(5));
      await de.doLoop(10);
      de.posts.length.should.equal(4);
      should.equal(de.channel.sipBlocks[0].p, 0);
      should.equal(de.channel.sipBlocks[0].l, 5);
      de.displayMe('');
      logger.info('curtime ', de.rs._curtime);
      // de.channel.sipBlocks[0].f.should.equal(0); // 1 // curtime
      expect(i(de.channel.sipBlocks[0].f)).to.equal(0); // curtime

      logger.set('level', 'info');
    });

  });

  describe(`${h.mtag}: B. State 2, has some bounds`, async function() {

    before(() => {
      logger.h1().info(this.title);

      sim = new SimulatedRemoteService(l(5), slogger, h.config);
      de = new DownloaderEngine(l(0), delogger);
      sim.linkToEngine(de);

      sim.setPost(l(1), Service.generateOrderedString(5));
      sim.setPost(l(2), Service.generateOrderedString(5));
      sim.setPost(l(3), Service.generateOrderedString(5));
      sim.setPost(l(4), Service.generateOrderedString(5));
    });

    describe(`${h.mtag}: B.1. State 2, _addMsg`, async function() {

      before( ()=> {logger.h1().info(this.title);});

      it(`${h.mtag}: B.1.1. update before`, async function() {
        logger.h2().info(this.test.title);

        await de.doLoop(1);
        de.posts.length.should.equal(1);

        sim.displayMe(); de.displayMe();

        await de._addMsg(l(0), Service.generateOrderedString(5));
        sim.displayMe(); de.displayMe();
        de.posts.length.should.equal(1); // ignored it

        await de._addMsg(l(2), Service.generateOrderedString(5));
        de.posts.length.should.equal(1); // ignored it

      });


      it(`${h.mtag}: B.1.2. update inside (mid, earliest,latest)`, async function() {
        logger.h2().info(this.test.title);

        // setup
        sim.resetSim(l(5), l(0));
        await de.doLoop(3);
        de.posts.length.should.equal(3);

        sim.displayMe(); de.displayMe();
        await de._addMsg(l(3), Service.generateOrderedString(5));
        // sim.displayMe(); de.displayMe();
        de.posts.length.should.equal(3);

        // on earliest bound
        await de._addMsg(l(2), Service.generateOrderedString(5));
        de.posts.length.should.equal(3);

        // on latest bound
        await de._addMsg(l(4), Service.generateOrderedString(5));
        de.posts.length.should.equal(3);
        de.displayMe();
      });


      describe(`${h.mtag}: B.1.3. update after`, function() {

        before(() => {logger.h1().info(this.title);});

        it(`${h.mtag}: B.1.3.1 update after with monitoring inside or before last`, async function() {
          logger.h2().info(this.test.title);

          // setup
          sim.resetSim(l(5), l(3));
          await de.doLoop(3);
          de.posts.length.should.equal(3);
          i(de.channel.e_mon).should.equal(3);

          await de._addMsg(l(6), Service.generateOrderedString(5));
          de.displayMe();
          de.posts.length.should.equal(4);
          i(de.channel.sipBlocks[0].l).should.equal(6);

        });

        it(`${h.mtag}: B.1.3.2 update after with monitoring outside last`, async function() {
          logger.h2().info(this.test.title);

          // Here, while the incoming message at time 6 should be fine, since there is
          // nothing between the last message (time 4) and this time (6), but we don't
          // know, so just throw away for now. Basically, we have not been monitoring,
          // from 4 to 5 seconds, so we can't accept 6. We don't know.

          // setup
          logger.info('e_mon: ', de.channel.e_mon);
          sim.resetSim(l(5), l(5));
          expect(sim._curtime.equals(l(5))).to.equal(true);
          logger.info('e_mon: ', de.channel.e_mon);
          await de.doLoop(3);
          de.posts.length.should.equal(3);
          logger.info('e_mon: ', de.channel.e_mon);
          i(de.channel.e_mon).should.equal(5);

          // add a message outside last, but after monitoring, so keep
          await de._addMsg(l(6), Service.generateOrderedString(5));
          sim.displayMe();
          de.displayMe();
          de.posts.length.should.equal(4);
          i(de.channel.sipBlocks[0].l).should.equal(6);
        });

      });

    });


    describe(`${h.mtag}: B.2. State 2, doLoop`, () => {

      before(() => {logger.h1().info(this.title);});

      it(`${h.mtag}: B.2.1. - monitoring is after last message (exclusive)`, async function() {
        logger.h2().info(this.test.title);
        logger.set('level', 'verbose');

        logger.verbose('  ...setup, no additional data');
        sim.resetSim(l(8), l(5)); await de.doLoop(3);
        de.posts.length.should.equal(3);
        sim.displayMe(); de.displayMe();
        logger.verbose('  ...finishes (note: since using current time now, sipBlocks[0].l is 8, so fetches back. if used monitoring time, then would have called fetchOnAndAfter)');
        await de.doLoop(5);
        de.displayMe();
        i(de.channel.sipBlocks[0].l).should.equal(8); // curtime
        de.posts.length.should.equal(4);
        logger.verbose('pick up earlier 1 if used mon time, but using curtime so nothing');
        await de.doLoop(3);
        de.posts.length.should.equal(4);

        logger.set('level', 'info');
      });

      describe(`${h.mtag}: B.2.2. - monitoring before last message`, function() {

        before(() => {logger.h1().info(this.title);});

        it(`${h.mtag}: B.2.2.1. - have first message, so stop. No data change.`, async function() {
          logger.h2().info(this.test.title);

          // setup, no additional data
          sim.resetSim(l(8), l(0)); await de.doLoop(5);
          de.posts.length.should.equal(4);
          sim.displayMe(); de.displayMe();
          i(de.channel.sipBlocks[0].f).should.equal(0); // sim.posts[0][0]); // curtime
          let found = await de.doLoop(5);
          found.should.equal(0);
          de.displayMe('after');
          de.posts.length.should.equal(4);
          i(de.channel.sipBlocks[0].f).should.equal(0); // sim.posts[0][0]);
          // expect(de.channel.sipBlocks[0].f.equals(Long.fromInt(0))).to.equal(true);   // curtime
        });


        // is there an edge case here?

        it(`${h.mtag}: B.2.2.2. - no first message, monitoring inside (inclusive) earliest/last`, async function() {
          logger.h2().info(this.test.title);

          // setup, no additional data, but found first message after query
          sim.resetSim(l(8), l(2)); await de.doLoop(4);
          de.posts.length.should.equal(4);
          sim.displayMe(); de.displayMe();
          i(de.channel.sipBlocks[0].f).should.equal(0); // sim.posts[0][0]); // curtime
          let found = await de.doLoop(5);
          found.should.equal(0);
          de.displayMe('after');
          de.posts.length.should.equal(4);
          i(de.channel.sipBlocks[0].f).should.equal(0); // sim.posts[0][0]);
          i(de.channel.sipBlocks[0].f).should.equal(0); // de.channel.sipBlocks[0].p);
          // expect(sim.posts[0][0]).to.equal(de.channel.sipBlocks[0].p); // NOTE: created this case because I set above two tests to 0
          // i(sim.posts[0][0]).should.equal(i(de.channel.sipBlocks[0].f));

        });


        it(`${h.mtag}: B.2.2.3. - no first message, monitoring before earliest`, async function() {
          logger.h2().info(this.test.title);

          sim.resetSim(l(8), l(0)); await de.doLoop(4);
          de.posts.length.should.equal(4);
          sim.displayMe(); de.displayMe();
          i(de.channel.sipBlocks[0].f).should.equal(0);
          let found = await de.doLoop(5);
          found.should.equal(0);
          de.displayMe('after');
          de.posts.length.should.equal(4);
          i(de.channel.sipBlocks[0].f).should.equal(0);
        });


        it(`${h.mtag}: B.2.2.3. - called with negative limit`, async function() {
          logger.h2().info(this.test.title);
          sim.resetSim(l(8), l(0));
          sim.displayMe(); de.displayMe();
          let found = await de.doLoop(-1);
          found.should.equal(0);
          should.equal(de.channel.sipBlocks[0].f, 0); // null);
        });

      });


    });

  });


  describe(`${h.mtag}: Ba - duplicate times so check ids`, function() {

    before(function() {
      logger.h1().info(this.title);

      sim = new SimulatedRemoteService(l(5), slogger, h.config);
      de = new DownloaderEngine(l(0), delogger);
      sim.linkToEngine(de);

      sim.setPost(l(1), Service.generateOrderedString(5));
      sim.setPost(l(2), Service.generateOrderedString(5));
      sim.setPost(l(2), Service.generateOrderedString(5));
      sim.setPost(l(3), Service.generateOrderedString(5));
      sim.setPost(l(3), Service.generateOrderedString(5));
      sim.setPost(l(3), Service.generateOrderedString(5));
      sim.setPost(l(4), Service.generateOrderedString(5));
      sim.setPost(l(5), Service.generateOrderedString(5));
    });


    it(`${h.mtag}: Ba.1. - Select 4`, async function() {
      logger.h2().info(this.test.title);

      sim.resetSim(l(4), l(0));
      await de.doLoop(4);
      sim.displayMe(); de.displayMe();
      de.posts.length.should.equal(4);
      // check order
      de.posts[1][1].should.equal(sim.posts[4][1]);
      de.posts[2][1].should.equal(sim.posts[5][1]);
      de.posts[3][1].should.equal(sim.posts[6][1]);
    });

    it(`${h.mtag}: Ba.2. - Select 4, then 2`, async function() {
      logger.h2().info(this.test.title);

      sim.resetSim(l(4), l(0));
      sim.displayMe();
      await de.doLoop(4);
      de.displayMe('should have 4 now');
      de.posts.length.should.equal(4);
      await de.doLoop(2).catch( (err)=> {
        console.log(err);
        err.message.should.equal('Looks like you pruned all messages returned... inf loop incoming unless you increase limit size');
      });
      await de.doLoop(3).catch( (err)=> {
        err.message.should.equal('Looks like you pruned all messages returned... inf loop incoming unless you increase limit size');
      });
      de.displayMe('pre doLoop 4');
      sim.displayMe();
      await de.doLoop(4);
      de.displayMe('should have 5 now since limit 4 overcame hurdle');
      de.posts.length.should.equal(5);

      // final check
      logger.with('color', 'red').info('  ... final check... limit 20');
      logger.info('  ... great test since this handle case where three msgs with same Incs occur.');
      await de.doLoop(20);
      await sim.setToTime(l(50));
      sim.compareToEngine();

    });

    it(`${h.mtag}: Ba.3. - Select 4, then 4, getting all 6`, async function() {
      logger.h2().info(this.test.title);

      logger.info('... reset 4,0');
      sim.resetSim(l(4), l(0));
      logger.info('... loop 4, resulting in curinc=4, sip:[null, 3, 4], pid:PQRST, lid:4567');
      await de.doLoop(4);
      logger.info('... loop 4, resulting in curinc=2, sip:[null, 2, 4], pid: K---, lid: 4567');
      await de.doLoop(4);
      sim.displayMe(); de.displayMe();
      de.posts.length.should.equal(5);
      await de.doLoop(1).catch( (err)=> {
        err.message.should.equal('Looks like you pruned all messages returned...'+
                                  ' inf loop incoming unless you increase limit size'); });
      de.posts.length.should.equal(5); // not getting any more
      logger.info('... loop 2');
      logger.setAspect('sipChannelData', true);
      logger.setAspect('pruneOnAndBefore', true);
      await de.doLoop(2);
      logger.setAspect('pruneOnAndBefore', false);
      logger.setAspect('sipChannelData', false);
      de.posts.length.should.equal(6); // got one more but still on time 2
      await de.doLoop(2).catch( (err)=> {
        err.message.should.equal('Looks like you pruned all messages returned...'+
                                  ' inf loop incoming unless you increase limit size'); });
      de.posts.length.should.equal(6); // not getting any more
      logger.info('... loop 3');
      await de.doLoop(3);
      de.posts.length.should.equal(7); // got it

      // final check
      logger.info('... loop 20');
      await de.doLoop(20);
      logger.info('... loop 50');
      await sim.setToTime(l(50));
      sim.compareToEngine();
    });


    it(`${h.mtag}: Ba.4. - fetch after tests`, async function() {
      logger.h2().info(this.test.title);
      sim.resetSim(l(1), l(0));
      sim.displayMe();
      logger.info('get 1, not setting first');
      await de.doLoop(1);
      de.displayMe();
      should.equal(de.channel.sipBlocks[0].f, 0); //  null);
      de.posts.length.should.equal(1); // got it

      logger.info('get 0, setting first so next time doLoop is called, gets after');
      await de.doLoop(2);
      de.displayMe();
      // de.channel.sipBlocks[0].f.should.equal(0); // 1);
      i(de.channel.sipBlocks[0].f).should.equal(0);
      de.posts.length.should.equal(1); // got it

      logger.h3().info('move monitoring time so we can simulate a restart');
      de.channel.e_mon = l(8);
      sim.displayMe();
      de.displayMe('pre');
      await de.doLoop(1);
      de.displayMe('post');
      de.posts.length.should.equal(2); // 1 and 5
      de.channel.sipBlocks.length.should.equal(2); // case 2 means we added a block
      i(de.channel.sipBlocks[0].p).should.equal(5);
      i(de.channel.sipBlocks[0].l).should.equal(8);
      i(de.channel.sipBlocks[1].f).should.equal(0);
      i(de.channel.sipBlocks[1].p).should.equal(0);
      i(de.channel.sipBlocks[1].l).should.equal(1);
      i(de.posts[0][0]).should.equal(1);
      i(de.posts[1][0]).should.equal(5);

      logger.h3().info('start fetching on this new block');
      await de.doLoop(2);
      de.displayMe();
      de.posts.length.should.equal(3); // 1 and 4, 5
      i(de.channel.sipBlocks[0].p).should.equal(4);
      i(de.channel.sipBlocks[0].l).should.equal(8);
      i(de.posts[0][0]).should.equal(1);
      i(de.posts[1][0]).should.equal(4);
      i(de.posts[2][0]).should.equal(5);

      logger.h3().info('finish fetching on this new block, but still distinct');
      sim.displayMe();
      await de.doLoop(10);
      de.displayMe();
      de.posts.length.should.equal(8); // all posts now
      de.channel.sipBlocks.length.should.equal(2); // still size 2
      i(de.channel.sipBlocks[0].p).should.equal(1);
      i(de.channel.sipBlocks[0].l).should.equal(8);
      de.channel.sipBlocks[0].finished.should.equal(true);

      logger.h3().info('merges blocks');
      await de.doLoop(10);
      de.displayMe();
      de.posts.length.should.equal(8); // all posts now
      de.channel.sipBlocks.length.should.equal(1); // still size 2

      /*
      logger.info('returned time 1 entry again so no change');
      de.posts.length.should.equal(1);
      await de.doLoop(2).catch( (err)=> {
        err.message.should.equal('Looks like you pruned all messages returned...'+
                                  ' inf loop incoming unless you increase limit size'); });
      de.displayMe();
      logger.info('fetched 2, time 1 and 1st time 2, keeping 1 so +1');
      de.posts.length.should.equal(2);

      await de.doLoop(2);
      de.displayMe();
      logger.info('fetched 2, both time 2, kept 2nd');
      de.posts.length.should.equal(3);

      await de.doLoop(2);
      de.displayMe();
      logger.info('fetched 2, both time 2, kept none');
      de.posts.length.should.equal(3);

      await de.doLoop(3);
      de.displayMe();
      logger.info('returned 3, both of the time 2 and time 3, keeping time 3');
      de.posts.length.should.equal(4);
      */

      // final check
      await de.doLoop(20);
      await sim.setToTime(l(50));
      sim.compareToEngine();
    });


  });

  describe(`${h.mtag}: C. Random data tests`, function() {
    logger.h1().info(this.title);

    before( () => {
      sim = new SimulatedRemoteService(l(5), slogger, h.config);
      de = new DownloaderEngine(l(0), delogger);
      sim.linkToEngine(de);
//        slogger.setLogTag('setToTime')
    });


    it(`${h.mtag}: C.1 randomized trials`, async function() {
      logger.h2().info(this.test.title);
      this.timeout(160000);

      // turn off logging
      slogger.setLogTag('fetchOnAndAfter', false);
      slogger.setLogTag('fetchOnAndBefore', false);

      let t = 5; // # trials
      let n = 5; // # datapoints
      let m = 10; // # different starting conditions (current and monitoring time)
      let cur = Math.round(Math.random() * 100.0);

      for (let i=0; i<t; i++) {

        logger.h3().info(`Begin trial: ${i}`);

        for (let j=0; j<n; j++) {
          cur += Math.round(Math.random() * 100.0);
          sim.setPost(l(cur), Service.generateOrderedString(5));
        }

        // Random starting location
        for (let j=0; j<m; j++) {
          logger.h3().info(`Starting location: ${j}`);
          sim.displayMe();

          let start_t = Math.round(Math.random() * (cur+(Math.random()*100.0))); // 0 to up to 100 past cur
          let start_m = Math.round(Math.random() * (start_t)); // 0 to start_t

          logger.info(` - curtime ${start_t}, monitored from ${start_m}, going to ${cur}`);

          // do all await sim.setToTime first, then do.doLoop (i.e. 'listen' for messages, then 'sip' for past ones)
          logger.h3().info(`* setToTime, then doLoop`);
          sim.resetSim(l(start_t), l(start_m));
          sim.displayMe(`monitor at ${start_m}`);
          if ( sim._curtime.lessThan(de.channel.e_mon) ) {
          }
          while ( sim._curtime.lessThan(l(cur)) ) {
            let newtime = Service.i(sim._curtime) + Math.round((Math.random() * 100.0));
            logger.info(`  - 1. setToTime : ${newtime}`);
            await sim.setToTime(l(newtime));
          }
          logger.info('- simulation out of messages to arrive, start sipping');
          sim.displayMe(`  before starting to sip: sim now`);
          de.displayMe(`  before starting to sip: de now`);
          logger.info('de.channel.sipBlocks.length ', de.channel.sipBlocks.length );
          while ( ! (de.channel.sipBlocks.length == 1 && de.channel.sipBlocks[0].finished == true) ) {
            let limit = Math.round( Math.random() * 5.0);
            logger.info(`  - 1. doLoop limit: ${limit}`);
            await de.doLoop(limit);
            de.displayMe(` ... now  ${JSON.stringify(de.channel.sipBlocks, null, '  ')}`);
            logger.info('de.channel.sipBlocks.length ', de.channel.sipBlocks.length, ' finished : ', de.channel.sipBlocks[0].finished );
          }
          sim.compareToEngine();

          // do all do.doLoop, then await sim.setToTime
          logger.h3().info(`* doLoop, then setToTime`);
          sim.resetSim(l(start_t), l(start_m));
          sim.displayMe(`monitor at ${start_m}`);
          de.displayMe();
          while ( de.channel.sipBlocks.length == 0 || ( ! (de.channel.sipBlocks.length == 1 && de.channel.sipBlocks[0].finished == true)) ) {
            let limit = Math.round( Math.random() * 50);
            logger.info(`  - 2. doLoop limit: ${limit}`);
            await de.doLoop(limit);
          }
          while ( sim._curtime.lessThan(l(cur)) ) {
            let newtime = Service.l(Math.round(Service.i(sim._curtime) + (Math.random() * 100.0)));
            logger.info(`  - 2. setToTime : ${newtime}`);
            await sim.setToTime(l(newtime));
          }
          logger.info('- simulation out of messages to arrive');
          sim.compareToEngine();

          // randomly choose until done
          logger.h3().info(`* random until done`);
          sim.resetSim(l(start_t), l(start_m));
          sim.displayMe(`monitor at ${start_m}`);
          while ( (de.channel.sipBlocks.length ==1 && !de.channel.sipBlocks[0].f.equals(l(0))) && sim._curtime.lessThan(l(cur)) ) {
//          while((de.channel.sipBlocks.length == 0 || de.channel.sipBlocks[0].f == null ) && sim._curtime < cur)
            if ( Math.random() < .5 ) {
              let limit = Math.round(Math.random() * 5.0);
              logger.info(`  - 3. doLoop limit: ${limit}`);
              await de.doLoop(limit);
            } else {
              let newtime = Math.round(sim._curtime + (Math.random() * 100.0));
              logger.info(`  - 3. setToTime : ${newtime}`);
              await sim.setToTime(l(newtime));
            }
          }


        }
      }

    });

  });

  after( function() {
  });

});
