
const uparse = require('url-parse');
let h = require('./msHelper')(__filename);
// let wtf = require('wtfnode');
let rl = wl = ov = req = reqhtml = null;
let logger = h.logger;

// new h.PE.Service.WEConfig(new Logger('config', {debug : true}));


describe(`${h.mtag}: Call local msRemoteListener funcitonality`, async () => {

  // setup the service
  before(async function() {
    this.timeout(7000);

//    logger.info('wtf dump: before @start');
//    wtf.dump();

    logger.verbose('... creating Requester');
    req = new PE.Service.Requester(logger);
    reqhtml = new PE.Service.Requester(logger, null, 'text/html');

    logger.h3().info('asdfadsfadsfadsfadsfasdfasdfasfads');
    try {
      if ( (await req.get('http://localhost:3010/api/v1/health')).success == false ) { logger.throwError('Testserver /health failed'); }
    } catch (err) {
      logger.h1().error('TestServer is not running');
      logger.error(' To run, type : "cd ../testserver && make run"');
      throw err;
    };

    logger.verbose('... creating overseer');
    ov = await h.genOV(null, true, true);
    await ov.RemoteListenerModel.deleteMany({});
    await ov.ChannelModel.deleteMany({});

    logger.verbose('... creating service');
    rl = await h.genRL(null, true, true);

    await rl.doShutdown();
    await ov.doShutdown();

//    logger.info('wtf dump: before @end');
//    wtf.dump();
  });

  describe(`${h.mtag}: simple start test`, async () => {

    /*
     * NOTE: added this to test for any left over connections... didn't find any, was not automated either so commented out
    it(`${h.mtag}: test if ov is creating lots of db connections b/c not shutting down`, async function() {
      logger.h3().info(this.test.title);
      this.timeout(20000);

      logger.info(`wtf dump: start of "${this.test.title}"`);
      wtf.dump();

      for (let i=0; i<10; i++) {
        // ov = await h.genOV(null, true, true);
        // await ov.doShutdown();
        rl = await h.genRL(null, true, true);
        await rl.doShutdown();
      }

      logger.info(`wtf dump: end of "${this.test.title}"`);
      wtf.dump();
    });
    */

    it(`${h.mtag}: call /health`, async function() {
      logger.h3().info(this.test.title);

      rl = await h.genRL(null, true, true);

      logger.info(`${h.mtag}: call /health `);
      let healthresult = await rl.onHealth();
      logger.info('hr: ', healthresult);
      expect(healthresult.success).to.equal(true);

      await rl.doShutdown();

      // logger.info('wtf dump: health'); wtf.dump();
    });

    it(`${h.mtag}: doAliveCheckin, passing`, async function() {
      logger.h3().info(this.test.title);
      // logger.set('level', 'verbose');
      this.timeout(8000);

      ov = await h.genOV(null, true, true);
      rl = await h.genRL(null, true, true);

      logger.verbose('... find RL entry in DB');
      let rls = await ov.RemoteListenerModel.find({_id : rl.remotelistenerEntry._id});
      expect(rls).to.be.lengthOf(1);

      await rl.doAliveCheckin();
      let rls2 = await ov.RemoteListenerModel.find({_id : rl.remotelistenerEntry._id});
      expect(rls2).to.be.lengthOf(1);

      logger.verbose('... compare dates, which should not be equal since rl did a checkin: ', 
        rls[0].updatedAt, rls2[0].updatedAt);
      expect(rls[0].updatedAt).to.not.equal(rls2[0].updatedAt);

      await rl.doShutdown();
      await ov.doShutdown();

      logger.set('level', 'info');

      // logger.info('wtf dump: doAliveChecking, passing'); wtf.dump();
    });

    it(`${h.mtag}: doAliveCheckin, fail isValid`, async function() {
      logger.h3().info(this.test.title);
      // logger.set('level', 'verbose');

      ov = await h.genOV(null, true, true);
      rl = await h.genRL(null, true, true);

      logger.verbose('... find RL entry in DB');
      let rls = await ov.RemoteListenerModel.find({_id : rl.remotelistenerEntry._id});
      expect(rls).to.be.lengthOf(1);
      rls[0].isValid = false;
      rls[0].markModified('isValid');
      await rls[0].save();

      logger.verbose('... Alive Checkin should throw exception now');
      let caught = false;
      try {
        await rl.doAliveCheckin();
      } catch (e) {
        logger.verbose('... caught isValid attempt to exit');
        caught = true;
      };
      expect(caught).to.equal(true);
      rls = await ov.RemoteListenerModel.find({_id : rl.remotelistenerEntry._id});
      expect(rls[0].isValid).to.equal(false);

      await rl.doShutdown();
      await ov.doShutdown();
      logger.set('level', 'info');

      // logger.info('wtf dump: doAliveChecking, fail isValid'); wtf.dump();
    });


    it(`${h.mtag}: doAliveCheckin, fail no entry`, async function() {
      logger.h3().info(this.test.title);
      logger.set('level', 'info');

      ov = await h.genOV(null, true, true);
      rl = await h.genRL(null, true, true);

      let rls = await ov.RemoteListenerModel.find({_id : rl.remotelistenerEntry._id});
      expect(rls).to.be.lengthOf(1);

      logger.verbose('... remove RL entry in DB');
      await ov.RemoteListenerModel.deleteMany({_id : rl.remotelistenerEntry._id});


      logger.verbose('... Alive Checkin should throw exception now');
      let caught = false;
      try {
        await rl.doAliveCheckin();
      } catch (e) {
        logger.verbose('... caught missing entry and attempt to exit');
        caught = true;
      };

      expect(caught).to.equal(true);
      rls = await ov.RemoteListenerModel.find({_id : rl.remotelistenerEntry._id});
      expect(rls).to.be.lengthOf(0);

      await rl.doShutdown();
      await ov.doShutdown();
      logger.set('level', 'info');

//      logger.info('wtf dump: doAliveChecking, fail no entry'); wtf.dump();
    });


    it(`${h.mtag}: doAliveCheckin, OV does checkRemoteListeners(0) to recover out of date RL`, async function() {
      logger.h3().info(this.test.title);
      logger.set('level', 'info');
      logger.verbose('... create a new RS');
      this.timeout(6000);

      ov = await h.genOV(null, true, true);
      rl = await h.genRL(null, true, true);

      let rls = await ov.RemoteListenerModel.find({_id : rl.remotelistenerEntry._id});
      expect(rls).to.be.lengthOf(1);
      logger.verbose('... get rid of RL since past update time (0 seconds)');


      logger.verbose('... should be none now');
      await ov.checkRemoteListeners(0);
      rls = await ov.RemoteListenerModel.find({_id : rl.remotelistenerEntry._id});
      expect(rls).to.be.lengthOf(0);

      logger.verbose('... Alive Checkin should throw exception now');
      let caught = false;
      try {
        await rl.doAliveCheckin();
      }
      catch (e) {
        logger.verbose('... caught missing entry and attempt to exit');
        caught = true;
      };
      expect(caught).to.equal(true);
      rls = await ov.RemoteListenerModel.find({_id : rl.remotelistenerEntry._id});
      expect(rls).to.be.lengthOf(0);

      await rl.doShutdown();
      await ov.doShutdown();

      logger.set('level', 'info');

      // logger.info('wtf dump: doAliveChecking, OV does ...'); wtf.dump();
    });


    it(`${h.mtag}: doCheckToEnableOwnChannels`, async function() {
      logger.h3().info(this.test.title);
      logger.set('level', 'verbose');
      this.timeout(22000);

      ov = await h.genOV(null, true, true);
      ts = await h.genTSRequester();
      wl = await h.genWL(true, true);
      rl = await h.genRL(null, true, true);
      rl.logger.set('level', 'verbose');

      logger.info('Channel Auth: call API, which calls WL /channel_auth');
      let dauth = await ts.post('/api/v1/user/protect/team/protect/channel', null,
        {
          session  : h.PE.Service.generateRandomString(),
          teamId   : 1,
          sourceId : 7,
          title    : 'NewChannel',
        });
      logger.info('dauth: ', dauth);
      expect(dauth.success).to.equal(true); // is testserver on?


      // This returns URL with /channel_start.
      // FOR PLTEST: This goes to the RS to create an OAuth token. This then returns to /channel_validatelaunch with
      //             the oauthtoken, t (channel token) and state (which is the token for PLTEST).
      // FOR OTHERS: Return from the RS to a link that handles teh return credentials from the RS. Then pass that to
      //             /channel_validatelaunch to save credentials.
      logger.info('WL /channel_start : ', dauth.data.url);
      let dch = await req.get(dauth.data.url);
      logger.info('/channel_start return (which ultimately comes from /channel_validate: ', dch);
      expect(dch.success).to.equal(true);
      // let valdata = uparse(dremoteauth.data).url, true).query;


      // logger.info(`Channel WL /channel_validatelaunch: t:${dauth.data.token} state: ${dauth.data.token} (state same as token in pltest)`);
      // let d_chlaunch = await req.post(`http://localhost:50105/v1/channel_validatelaunch?oauthtoken=${valdata.oauthtoken}&state=${dauth.data.token}&token=${dauth.data.token}`);
      // let d_chlaunch = await req.post(`http://localhost:50105/v1/channel_validatelaunch?state=${dauth.data.token}&token=${dauth.data.token}`);
      // logger.info('d_chlaunch: ', d_chlaunch); // dremoteauth);
      // expect(d_chlaunch.success).to.equal(true);

      logger.info('let RL grab channel, which is inactive (i.e. validated), and start it running');
      // let ur = uparse(dremoteauth.meta.url, true);
      // logger.info('ur: ', ur);
      let sc = await rl.doStartChannel({token : dauth.data.token});
      logger.info('start channel result: ', sc);


      logger.verbose('... forcing channel isActive to be "starting", emulating an error state');
      channels = await ov.ChannelModel.find();
      logger.info('channels 1 : ', channels);
      expect(channels).to.be.lengthOf(1);
      expect(channels[0].isActive).to.equal('running');
      channels[0].isActive='starting';
      channels[0].markModified('isActive');
      await channels[0].save();
      channels = await ov.ChannelModel.find();
      logger.info('channels 2 : ', channels);

      logger.verbose('... have the RL recover its own channel');
      await rl.doCheckToEnableOwnChannels();

      logger.verbose('... checking channel isActive');
      logger.info('channels 3 : ', channels);
      channels = await ov.ChannelModel.find();
      expect(channels).to.be.lengthOf(1);
      expect(channels[0].isActive).to.equal('running');

      logger.verbose('ov dbid, isconnected ', ov.db.id, ov.db.isConnected());
      logger.verbose('rl shutdown');
      await rl.doShutdown();
      logger.verbose('ov dbid, isconnected ', ov.db.id, ov.db.isConnected());
      logger.verbose('wl shutdown');
      await wl.doShutdown();

      logger.verbose('ov dbid, isconnected ', ov.db.id, ov.db.isConnected());
      // channels should be different after RL shutdown
      logger.info('ov ChannelModel: ', ov.ChannelModel);
      channels = await ov.ChannelModel.find({});
      logger.verbose('ov channelmodel found');
      logger.verbose('channels: ', channels);
      expect(channels).to.be.lengthOf(1);
      expect(channels[0].isActive).to.equal('inactive'); // turned off when lr shutdown
      expect(channels[0].remotelistenerID).to.equal(null);

      // channel exists, even though turned off
      logger.verbose('ov delete many');
      await ov.ChannelModel.deleteMany({});
      logger.verbose('ov cm find, dbid ', ov.ChannelModel.id);
      channels = await ov.ChannelModel.find();
      expect(channels).to.be.lengthOf(0);
      logger.verbose('ov shutdown');
      await ov.doShutdown();
      logger.verbose('ts close');
      await ts.close();

//      logger.info('wtf dump: doCheckToEnableOwnChannels'); wtf.dump();
    });


    it(`${h.mtag}: RL:: Seek New Channels`, async function() {
      logger.h3().info(this.test.title);
      logger.set('level', 'verbose');
      this.timeout(10000);

      let ts = await h.genTSRequester();
      ov = await h.genOV(null, true, true);
      wl = await h.genWL(true, true);
      rl = await h.genRL(null, true, true);

      logger.verbose(`Create a RL, with a bunch of channels`);
      for (let i=0; i<3; i++) {
        // let dauth = await ts.get('/auth?teamId=1');
        let dauth = await ts.post('/api/v1/user/protect/team/protect/channel', null,
          {
            session  : h.PE.Service.generateRandomString(),
            teamId   : 1,
            sourceId : 7,
            title    : 'NewChannel',
          });
        expect(dauth.success).to.equal(true);
        logger.info('dauth', dauth);
        logger.info('dauth data ', dauth.data);
        logger.info('sending get to ', dauth.data.url);

        /*
        let dremoteauth = await req.get(dauth.data.url);
        logger.info('d_remoteauth: ', dremoteauth);
        expect(dremoteauth.success).to.equal(true);
        */
        let dremoteauth = await reqhtml.get(dauth.data.url);
        // logger.info('d_remoteauth: ', dremoteauth);
        expect(dremoteauth.success).to.equal(true);
        let valdata = uparse(dremoteauth.meta.url, true).query;

        // let d_chlaunch = await reqhtml.get(`http://localhost:50105/v1/channel_validatelaunch?oauthtoken=${valdata.oauthtoken}&state=${valdata.state}&token=${valdata.t}`);
        let d_chlaunch = await req.post(`http://localhost:50105/v1/channel_validatelaunch?oauthtoken=${valdata.oauthtoken}&state=${valdata.state}&token=${valdata.t}`);
        logger.info('d_chlaunch: ', dremoteauth);

        let ur = uparse(dremoteauth.meta.url, true);
        logger.info('ur: ', ur);
        let sc = await rl.doStartChannel({token : ur.query.t});
        logger.info('start channel result: ', sc);

      }
      channels = await ov.ChannelModel.find();
      logger.info('channels: ', channels);
      expect(channels).to.be.lengthOf(3); // 1+3 just created

      logger.h3().verbose(`kill the RL, freeing those channels, via OV.checkRemoteListeners(0)`);
      logger.info('current RL id is ', rl.remotelistenerEntry._id);
      // await rl.doShutdown(); rl = await h.genRL(null, true, true);

      await ov.checkRemoteListeners(0);
      channels = await ov.ChannelModel.find();
      expect(channels).to.be.lengthOf(3);
      for (let i=0; i<3; i++) {
        expect(channels[i].isActive).to.equal('inactive');
      }

      logger.verbose(`create a new RL, and have it grab the channels`);
      await rl.doShutdown();
      rl = await h.genRL(null, true, true);
      await rl.doSeekNewChannels();
      await rl.doSeekNewChannels();
      channels = await ov.ChannelModel.find();
      expect(channels).to.be.lengthOf(3);
      for (let i=0; i<3; i++) {
//        logger.info(`channel ${i}: `,channels[i]);
        expect(channels[i].remotelistenerID).to.equal(''+rl.remotelistenerEntry._id);
        expect(channels[i].isActive).to.equal('running');
      }

      await rl.doShutdown();
      await wl.doShutdown();
      await ov.doShutdown();
      await ts.close();
      logger.set('level', 'info');

      // logger.info('wtf dump: Seek New Channels'); wtf.dump();
    });


  });


  after(async function() {
    logger.h1().info('AFTER CALLED');
    // logger.info('wtf dump: after at start'); wtf.dump();

    await req.close(); // doesn't do much, or is it async
    /*
    await Promise.all([
      await rl.doShutdown().then(function() {logger.info('rl');}),
//      await wl.doShutdown().then(function() {logger.info('wl');}),
      await ov.doShutdown().then(function() {logger.info('ov');})]);
      */

//    logger.info('wtf dump: after at end'); wtf.dump();
  });

});

