
const Logger     = require('woveon-logger');

const Service    = require('../service/service');
let config       = require('../service/config');


module.exports = () => {

  let mtag = require('path').basename(__filename).slice(0, -3);
  let logger = new Logger(mtag, {showName: false, debug: true, level: 'info'});

  describe(`${mtag}: A - encryption of service-wide data.`, function() {
    logger.h1().info(this.title);


    it(`${mtag}: A.1 test string, number and object`, function() {
      logger.h2().info(this.test.title);

      try {
        // allow async/await
        (async () => {
          let e      = null;
          let d      = null;
          let msg    = null;
          let number = null;


          msg = 'Hello there';
          logger.h3().info(`msg: '${msg}', ${JSON.stringify(msg)}`);
          e = Service.encrypt(config, msg);
          logger.info(`e  : '${e}'`);
          d = Service.decrypt(config, e);
          logger.info(`d  : '${d}'`);
          console.assert(msg === d);


          number = 2017;
          logger.h3().info(`number: '${number}' ${JSON.stringify(number)}`);
          e = Service.encrypt(config, number);
          logger.info(`e  : '${e}'`);
          d = Service.decrypt(config, e);
          logger.info(`d  : '${d}'`);
          console.assert(number === d);


          obj = {a: 1, b: 'asf'};
          logger.h3().info(`obj: '${obj}' ${JSON.stringify(obj)}`);
          e = Service.encrypt(config, obj);
          logger.info(`e  : '${e}'`);
          d = Service.decrypt(config, e);
          logger.info(`d  : '${JSON.stringify(d)}'`);
          console.assert(JSON.stringify(obj) === JSON.stringify(d));

        })();

      } catch (err) {
        logger.info(err);
        throw new Error('err');
      };
    });
  });
};
