

// Imported Code
const should            = require('should');

// Actual Code
const config            = require('../service/config');
const Requester         = require('../service/requester');
const RemoteListenerService     = require('../microservices/remoteListenerService');
const Logger            = require('woveon-logger');

const ChannelModel      = require('../models/channelModel');
const RemoteListenerModel       = require('../models/remoteListenerModel');

let service           = null;
let channelModel      = null;
let remotelistenerModel       = null;

module.exports = () => {

  let mtag = require('path').basename(__filename).slice(0, -3);
  let logger = new Logger(mtag, { debug: true, showName: true });

  describe(`${mtag}: Call msRemoteListener functionality`, () => {


    // setup the service
    before( async () => {
      config.service.port = 0;
      service = new RemoteListenerService(config);
      config.service.port = process.env.WOV_ple_rl_port;
      await service.init();
      await service.startup();
    });

    it(`${mtag}: `, async function() {
      this.timeout(0);
      logger.info(`${mtag}: `);
      await new Promise( (res,rej) => {
        setTimeout(()=>{ res(true); },10000);
      });
    });

    after( async () => {
      await service.shutdown();
    });

  });
};
