
// Designed to test a plugin against during development
const Logger            = require('woveon-logger');
const C                 = require('../../pltest/src/pltestconfig');
// if ( ! C.isInited() ) { new C(new Logger('config', {debug : true})); }
new C(new Logger('config', {debug : true}));

const RoutesBrowser     = require('./routesBrowser');
const RoutesChannel     = require('./routesChannel');
const Channel           = require('./channel');

const WEService         = require('../../src/service');


/**
 * TestServer emulates the browser, api and remote service, in order to support
 * the plugin development.
 */

// Guts of server...
global.serverObj = null;


global.initServerObj = function() {
  return {
    listener      : null,
    logger        : null,
    requester     : null,
    requesterHtml : null,
    serverstate   : {
      /*{
        ver         : process.env.WOV_api_ver,
        redirectUrl : process.env.WOV_testserver_redirectUrl, // for pseudo oauth
        service     : {
          port    : 3010, // process.env.WOV_testserver_port,
          address : null,
        },
        wl : {url : 'http://localhost:50105'},
        rl : {url : 'http://localhost:50106'},
      },*/
      channels : {
      },
    },
  };
};

/**
 *
 * @param {*} _serverObj
 */
global.startServer = async function(_serverObj) {

  await C.blockForInit();

  // if ( process.env.WOV_useDB && Channel.db == undefined) {await Channel.onInit();}
  await Channel.onInit();

  // reinit serverObj
  if ( _serverObj.requester != undefined ) _serverObj.requester = null;
  if ( _serverObj.requesterHtml != undefined ) _serverObj.requesterHtml = null;
  if ( _serverObj.listener != undefined ) {
    _serverObj.logger.info('closing listener');
    _serverObj.listener.close();
  }
  if ( _serverObj.logger != undefined ) _serverObj.logger = null;
  Channel.serverstate = _serverObj.serverstate;

  // restart
  _serverObj.logger = new Logger('testserver',
    {showName : true, debug : true, level : 'verbose'},
    {listener : true, requester : true});

  _serverObj.listener      = new WEService.Listener(C.get('WOV_api_port_ext'), _serverObj.logger, 'static');
  _serverObj.requester     = new WEService.Requester(_serverObj.logger);
  _serverObj.requesterHtml = new WEService.Requester(_serverObj.logger, null, 'text/html');
  await _serverObj.listener.init();
  RoutesBrowser.addRoutes(_serverObj);
  RoutesChannel.addRoutes(_serverObj);
  global.serverObj = _serverObj;
  _serverObj.listener.listen();
};


global.serverObj = initServerObj();
startServer(global.serverObj);
