
/**
 * Routes used basically for debugging.
 */

const fs = require('fs');

const Channel = require('./channel');
const WovReturn = require('woveon-service').WovReturn;
const WEConfig = require('../../src/service').WEConfig; // created in index.js

module.exports = {

  logger : null,

  addRoutes(_server) {

    _server.listener.onGet(`/api/${ WEConfig.get('WOV_api_ver')}/health`, (args, res) => {return WovReturn.retSuccess(true);}, __filename);

    _server.listener.onGet('/u/list', rbList, __filename);
    _server.listener.onGet('/u/channeloauth', rbChannelOAuth, __filename);


    async function rbList(_args, res) {
      _server.logger.info('from: ', res.req.originalUrl);
      _server.logger.info('args:', _args);
      let retval = null;
      let result = null;

      if ( _args.id != undefined ) {
        result= JSON.stringify(await Channel.getChannel(_args.id), null, '  ');
      } else result =  JSON.stringify(_server.serverstate.channels);

      return WovReturn.retSuccess(result);
    };

    async function rbChannelOAuth(_args) {
      let retval = WovReturn.checkAttributes(_args, ['token']);
      if ( retval == null ) { 
        retval = WovReturn.retSuccess(Channel.getOAuthToken(_args.token)); 
      }
      return retval;
    }


    /**
     * Save the data to a file.
     */
    _server.listener.onGet('/u/save', rbSave, __filename);
    async function rbSave(args, res) {
      let name = args.name || 'default';
      fs.writeFileSync('./data/'+name+'.json', JSON.stringify(_server.serverstate, null, '  '), 'utf8');
      let r = {success : true};
      return _server.listener.retSucess(r);
    };


    /** */
    _server.listener.onGet('/u/reload', rbReload, __filename);
    async function rbReload(args, res) {
      let r = initServerObj();
      global.serverObj.serverstate = r.serverstate;
      startServer(serverObj);
      return _server.listener.retSucess(true);
    };


    /**
     *
     */
    _server.listener.onGet('/u/load', rbLoad, __filename);
    async function rbLoad(args, res) {
      let name = args.name || 'default';
      try {
        let json = JSON.parse(fs.readFileSync('./data/'+name+'.json', 'utf8'));
        let cc = json.channels;
        global.serverObj.serverstate = json;
        global.startServer(global.serverObj);

        // make all classes
        global.serverObj.serverstate.channels = {};
        let k = Object.keys(cc);
        for (let i=0; i<k.length; i++) {
          let c = cc[k];
          new Channel(c);
        }
        _server.logger.info('restarted server channels ', serverObj.serverstate.channels);

      } catch (e) {_server.logger.throwError(e);}

      return _server.listener.retSucess(true);
    };
  },

};
